Index: lib/spatial/mapbuilder/lib/widget/DeleteFeature.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/DeleteFeature.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/DeleteFeature.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: DeleteFeature.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -22,33 +22,42 @@
   // cursor can be changed by spefying a new cursor in config file
   this.cursor = "default"; 
 
-  this.trm=widgetNode.selectSingleNode("mb:transactionResponseModel").firstChild.nodeValue;
-  this.tm=widgetNode.selectSingleNode("mb:targetModel").firstChild.nodeValue;
-  this.tc=widgetNode.selectSingleNode("mb:targetContext").firstChild.nodeValue;
+  this.trm=this.getProperty("mb:transactionResponseModel");
+  this.tm=this.getProperty("mb:targetModel");
+  this.tc=this.getProperty("mb:targetContext");
 
   this.httpPayload=new Object();
-  this.httpPayload.url=widgetNode.selectSingleNode("mb:webServiceUrl").firstChild.nodeValue;
+  this.httpPayload.url=this.getProperty("mb:webServiceUrl");
   this.httpPayload.method="post";
 
   /** Xsl to convert Feature into a WFS Transaction Delete. */
   this.deleteXsl=new XslProcessor(baseDir+"/tool/xsl/wfs_Delete.xsl");
 
+  /** creates the OL control for this button */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class(OpenLayers.Control, {
+      CLASS_NAME: 'mbDeleteFeature',
+      type: OpenLayers.Control.TYPE_BUTTON
+    });
+    return Control;
+  }
+
   /**
    * Start a WFS-T DeleteFeature transaction.
    * @param objRef Pointer to this object.
    */
-  this.doSelect = function(selected,objRef) {
+  this.doSelect = function(objRef, selected) {
     if (selected){
       // Model that will be populated with the WFS response.
       if (!objRef.transactionResponseModel){
-        objRef.transactionResponseModel=eval("config.objects."+objRef.trm);
+        objRef.transactionResponseModel=window.config.objects[objRef.trm];
         objRef.transactionResponseModel.addListener("loadModel",objRef.handleResponse, objRef);
       }
       if (!objRef.targetModel){
-        objRef.targetModel=eval("config.objects."+objRef.tm);
+        objRef.targetModel=window.config.objects[objRef.tm];
       }
       if (!objRef.targetContext){
-        objRef.targetContext=eval("config.objects."+objRef.tc);
+        objRef.targetContext=window.config.objects[objRef.tc];
       }
       fid=objRef.targetModel.getXpathValue(objRef.targetModel,"//@fid");
       //if fid exists, then we are deleting an existing feature.
@@ -55,8 +64,9 @@
       if (objRef.targetModel.doc && fid){
         s=objRef.deleteXsl.transformNodeToObject(objRef.targetModel.doc);
         objRef.httpPayload.postData=s;
+        objRef.transactionResponseModel.transactionType="delete";
         objRef.transactionResponseModel.newRequest(objRef.transactionResponseModel,objRef.httpPayload);
-      }else alert("No feature available to delete");
+      }else alert(mbGetMessage("noFeatureToDelete"));
     }
   }
 
@@ -67,15 +77,18 @@
    * @param objRef Pointer to this object.
    */
   this.handleResponse=function(objRef){
-    sucess=objRef.transactionResponseModel.doc.selectSingleNode("//wfs:TransactionResult/wfs:Status/wfs:SUCCESS");
-    if (sucess){
-      // Remove FeatureList if feature entry was successful.
-      httpPayload=new Object();
-      httpPayload.url=null;
-      objRef.targetModel.newRequest(objRef.targetModel,httpPayload);
-      // Repaint the WMS layers
-      objRef.targetContext.callListeners("refreshWmsLayers");
+    if (objRef.transactionResponseModel.transactionType=="delete") {
+      success=objRef.transactionResponseModel.doc.selectSingleNode("//wfs:TransactionResult/wfs:Status/wfs:SUCCESS");
+      if (success){
+        // Remove FeatureList if feature entry was successful.
+        objRef.targetModel.setModel(objRef.targetModel,null);
+
+        // Repaint GmlRenderers
+        objRef.targetModel.callListeners("refreshGmlRenderers");
+
+        // Repaint the WMS layers
+        objRef.targetContext.callListeners("refreshWmsLayers");
+      }
     }
   }
-
 }
Index: lib/spatial/mapbuilder/lib/widget/Timestamp.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Timestamp.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Timestamp.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Timestamp.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -17,9 +17,15 @@
 function Timestamp(widgetNode, model) {
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
 
+  //set some properties for the form output
+  this.formName = "TimestampForm_" + mbIds.getId();
+  this.stylesheet.setParameter("formName", this.formName);
+
   this.updateTimestamp = function (objRef, timestamp) {
-    var inputEl = document.getElementById("timestampValue");
-    inputEl.value = objRef.model.timestampList.childNodes[timestamp].firstChild.nodeValue;
+    var form = document[objRef.formName];
+    if (form) {
+      form.timestampValue.value = getNodeValue(objRef.model.timestampList.childNodes[timestamp]);
+    }
   }
 
   this.model.addListener("timestamp",this.updateTimestamp, this);
Index: lib/spatial/mapbuilder/lib/widget/Button.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Button.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Button.xsl	(revision 4307)
@@ -1,40 +1,9 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0" 
-  xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-<!--
-Description: Convert Mapbuilder Config to a button image and link.  This stylesheet 
-            takes a Button node from config as input.  The link executes two
-            Javascript methods:
-            - button.select() see ButtonBase
-            - config.objects.$action where $action is a objectReference.method() 
-              specified in config.
-Author:      Mike Adair
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-ButtonBar.xsl,v 1.5 2004/03/25 21:25:43 madair1 Exp
--->
-
-  <xsl:output method="xml" omit-xml-declaration="yes"/>
-  
-  <!-- The common params set for all widgets -->
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-  <xsl:param name="action"/>
-  <xsl:param name="skinDir" select="/mb:MapbuilderConfig/mb:skinDir"/>
-
-  <!-- Text params for this widget -->
-  <xsl:param name="tooltip">set the tooltip property in WidgetText file</xsl:param>
-  <xsl:param name="buttonText"/>
-    
-  <xsl:template match="*">
-    <xsl:param name="linkUrl">javascript:config.objects.<xsl:value-of select="$widgetId"/>.select()<xsl:if test="$action">;config.objects.<xsl:value-of select="$action"/></xsl:if></xsl:param>
-    <xsl:param name="imageID"><xsl:value-of select="@id"/>_image</xsl:param>
-    <xsl:param name="imageSrc"><xsl:value-of select="mb:disabledSrc"/></xsl:param>
-    <a href="{$linkUrl}" class="mbButton">
-      <xsl:if test="string-length($imageSrc)>0"><img src="{$skinDir}{$imageSrc}" id="{$imageID}" title="{$tooltip}" border="0"/></xsl:if>
-      <xsl:if test="string-length($buttonText)>0"><xsl:value-of select="$buttonText"/></xsl:if>
-    </a>
-  </xsl:template>
-
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="action"/><xsl:param name="skinDir" select="/mb:MapbuilderConfig/mb:skinDir"/><xsl:param name="tooltip">set the tooltip property in WidgetText file</xsl:param><xsl:param name="buttonText"/><xsl:param name="cssName"/><xsl:template match="*"><xsl:param name="linkUrl">javascript:config.objects.<xsl:value-of select="$widgetId"/>.select()<xsl:if test="$action">;config.objects.<xsl:value-of select="$action"/></xsl:if></xsl:param><xsl:param name="imageID"><xsl:value-of select="@id"/>_image</xsl:param><xsl:param name="disabledSrc"><xsl:value-of select="mb:disabledSrc"/></xsl:param><xsl:param name="enabledSrc"><xsl:value-of select="mb:enabledSrc"/></xsl:param><style>
+      .olControlPanel .<xsl:value-of select="$cssName"/>Active {
+		background-image: url('<xsl:value-of select="concat($skinDir,$enabledSrc)"/>');
+      }
+      .olControlPanel .<xsl:value-of select="$cssName"/>Inactive {
+		background-image: url('<xsl:value-of select="concat($skinDir,$disabledSrc)"/>');
+      }
+    </style></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/GmlRendererConfig.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/GmlRendererConfig.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/GmlRendererConfig.js	(revision 4307)
@@ -0,0 +1,36 @@
+/*
+Author:       Andreas Hocevar andreas.hocevarATgmail.com
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: GmlRendererConfig.js 3879 2008-02-27 14:20:29Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/GmlRendererBase.js");
+
+/**
+ * Configuration for GmlRendererOL.
+ * This widget is used in models that merge into a MergeModel to specify
+ * a GmlRenderer configuration (sld, cursor style). The GmlRendererOL in
+ * the MergeModel will check for configurations in source models and use
+ * them.
+ * @constructor
+ * @base GmlRendererBase
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function GmlRendererConfig(widgetNode, model) {
+  GmlRendererBase.apply(this,new Array(widgetNode, model));
+  
+  var targetWidget = this.getProperty('mb:targetWidget');
+  
+  this.init = function(objRef) {
+    if (targetWidget) {
+      if (!model.config) {
+        model.config = {};
+      }
+      model.config[targetWidget] = objRef.config;
+    }
+  }
+  model.addListener('init', this.init, this);
+}
Index: lib/spatial/mapbuilder/lib/widget/ModelStatus.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ModelStatus.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ModelStatus.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: ModelStatus.js 1671 2005-09-20 02:37:54Z madair1 $
 */
 
 // Ensure this object's dependancies are loaded.
Index: lib/spatial/mapbuilder/lib/widget/TabbedContent.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TabbedContent.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/TabbedContent.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair/Fedele Stella
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: TabbedContent.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -21,17 +21,9 @@
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
 
   this.selectedTab = null;
-  var textNodeXpath = "/mb:WidgetText/mb:widgets/mb:TabbedContent";
-  this.tabLabels = config.widgetText.selectNodes(textNodeXpath);
+  this.tabList = new Array();
+  this.textNodeXpath = "/mb:WidgetText/mb:widgets/mb:TabbedContent";
 
-  //find the workspace node controlled by these tabs
-  var workspace = widgetNode.selectSingleNode("mb:htmlWorkspace");
-  if ( workspace ) {
-    this.htmlWorkspace = workspace.firstChild.nodeValue;
-  } else {
-    alert("htmlWorkspace must be defined for TabbedContent widget");
-  }
-
   /**
    * Initializes the tab list and sets the label for each tab
    * @param objRef a pointer to this object
@@ -40,24 +32,22 @@
     var tabs = objRef.widgetNode.selectNodes("mb:tab");
     for (var i=0; i<tabs.length; ++i) {
       var tab = tabs[i];
-      var tabWidgetId = tab.firstChild.nodeValue;
+      var tabWidgetId = getNodeValue(tab);
       var tabWidget = config.objects[tabWidgetId];
       if (!tabWidget) {
-        alert("tab widget not found:"+tabWidgetId);
+        alert(mbGetMessage("tabWidgetNotFound", tabWidgetId));
         return;
       }
 
-      tabWidget.htmlTagId = objRef.htmlWorkspace;
-      tabWidget.outputNodeId = objRef.id+"_workspace";
-      tabWidget.node = document.getElementById(tabWidget.htmlTagId);
-      tabWidget.tabList = objRef;
+      objRef.tabList.push(tabWidget);
 
       var tabLabel = tab.getAttribute("label"); 
       if (!tabLabel) tabLabel = tabWidgetId;
-      var textNode = config.widgetText.selectSingleNode(textNodeXpath+"/mb:"+tabWidgetId);
-      if (textNode) tabLabel = textNode.firstChild.nodeValue;
+      var textNode = config.widgetText.selectSingleNode(objRef.textNodeXpath+"/mb:"+tabWidgetId);
+      if (textNode) tabLabel = getNodeValue(textNode);
       tab.setAttribute("label",tabLabel);
       
+      tabWidget.model.addListener("refresh",objRef.paint,objRef);
       tabWidget.model.addListener("refresh",objRef.selectTab,tabWidget);
     }
   }
@@ -69,14 +59,11 @@
    * @param order  the order within the tabs
    */
   this.addWidget = function(tabWidget,tabLabel) {
-    tabWidget.htmlTagId = this.htmlWorkspace;
-    tabWidget.outputNodeId = this.id+"_workspace";
-    tabWidget.node = document.getElementById(tabWidget.htmlTagId);
-    tabWidget.tabList = this;
+    this.tabList.push(tabWidget);
 
     if (!tabLabel) tabLabel = tabWidget.id;
-    var textNode = config.widgetText.selectSingleNode(textNodeXpath+"/mb:"+tabWidget.id);
-    if (textNode) tabLabel = textNode.firstChild.nodeValue;
+    var textNode = config.widgetText.selectSingleNode(this.textNodeXpath+"/mb:"+tabWidget.id);
+    if (textNode) tabLabel = getNodeValue(textNode);
 
     var tabNode = this.model.doc.createElementNS(mbNS,"tab");
     tabNode.appendChild(this.model.doc.createTextNode(tabWidget.id));
@@ -94,18 +81,18 @@
    */
   this.selectTab = function(tabWidget) {
     if (!tabWidget.model.doc) {
-      alert("no data to show yet");
+      alert(mbGetMessage("noDataYet"));
       return;
     }
-    var tabList = tabWidget.tabList;
-    if (tabList.selectedTab!=null) tabList.selectedTab.className = '';
-    var newAnchor = document.getElementById(tabList.id+"_"+tabWidget.id);
+    var tabBar = config.objects[tabWidget.tabBarId]
+    if (tabBar.selectedTab!=null) tabBar.selectedTab.className = '';
+    var newAnchor = document.getElementById(tabBar.id+"_"+tabWidget.id);
     if (newAnchor) {
       newAnchor.className = 'current';
-      tabList.selectedTab = newAnchor;
-      tabWidget.paint(tabWidget,true);
+      tabBar.selectedTab = newAnchor;
+      tabWidget.paint(tabWidget,tabWidget.id);
     }
-    //tabWidget.targetModel.callListeners("refresh");
+    if (tabWidget.tabAction) eval(tabWidget.tabAction);
   }
 
   /**
@@ -114,6 +101,19 @@
    */
   this.prePaint = function(objRef){
     objRef.resultDoc = objRef.widgetNode;
+    for (var i=0; i<objRef.tabList.length; ++i) {
+      var tabWidget = objRef.tabList[i];
+      tabWidget.tabBarId = this.id;
+      var tabNode = objRef.resultDoc.selectSingleNode("mb:tab[text()='"+tabWidget.id+"']");
+      if (!tabWidget.model.doc) {
+        tabNode.setAttribute("disabled", "true");
+      } else {
+        tabNode.removeAttribute("disabled");
+      }
+
+      //specify an optional action to be performed when the tab is selected
+      this.tabAction = this.getProperty("mb:tabAction");
+    }
   }
 
 }
Index: lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.xsl	(revision 4307)
@@ -0,0 +1,2 @@
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:atom="http://www.w3.org/2005/Atom" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0" exclude-result-prefixes="xlink"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8"/><xsl:strip-space elements="*"/><xsl:param name="lang">en</xsl:param><xsl:param name="title"/><xsl:param name="widgetId"/><xsl:template match="/atom:feed"><div><xsl:if test="/atom:feed/atom:title"><h3><xsl:value-of select="/atom:feed/atom:title"/></h3></xsl:if><ul><xsl:apply-templates select="atom:entry"/></ul></div></xsl:template><xsl:template match="atom:entry"><xsl:param name="linkUrl">javascript:config.objects.<xsl:value-of select="$widgetId"/>.switchModel(config.objects.<xsl:value-of select="$widgetId"/>,'<xsl:value-of select="atom:content/@src"/>')</xsl:param><li><a href="{$linkUrl}"><xsl:value-of select="atom:title"/></a></li></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/EventLog.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/EventLog.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/EventLog.xsl	(revision 4307)
@@ -1,79 +1,12 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0"
-xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder"
-xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Show an event log, used for debugging.
-Author:      Mike Adair
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
-$Name$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <xsl:param name="listenerFilter"></xsl:param>
-  <xsl:param name="targetFilter"></xsl:param>
-
-  <!-- Main html -->
-  <xsl:template match="/mb:Logger">
-    <div style="height:300px;overflow:scroll">
-    <table border="1">
-      <tr>
-        <td colspan="2">
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="listenerFilter"/><xsl:param name="targetFilter"/><xsl:template match="/mb:Logger"><div style="height:300px;overflow:scroll"><table border="1"><tr><td colspan="2">
           Event Log
-        </td>
-        <td>
-          <a href="javascript:window.logger.clearLog();">Clear</a> - 
+        </td><td><a href="javascript:window.logger.clearLog();">Clear</a> - 
           <a href="javascript:window.logger.callListeners('refresh');">Refresh</a> - 
-          <a href="javascript:window.logger.saveLog();">Save</a>
-        </td>
-      </tr>
-      <tr>
-        <th>
+          <a href="javascript:window.logger.saveLog();">Save</a></td></tr><tr><th>
           Event
-        </th>
-        <th>
+        </th><th>
           Listener
-        </th>
-        <th>
+        </th><th>
           Target
-        </th>
-      </tr>
-      <xsl:choose>
-        <xsl:when test="string-length($listenerFilter)>0">              
-          <xsl:choose>
-            <xsl:when test="string-length($targetFilter)>0">              
-              <xsl:apply-templates select="event[@listener=$listenerFilter and @target=$targetFilter]"/>
-            </xsl:when>
-            <xsl:otherwise>
-              <xsl:apply-templates select="event[@listener=$listenerFilter]"/>
-            </xsl:otherwise>
-          </xsl:choose>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:apply-templates select="event"/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </table>
-    </div>
-  </xsl:template>
-  
-  <xsl:template match="event">
-    <tr>
-      <td>
-        <xsl:value-of select="."/>
-      </td>
-      <td>
-        <xsl:value-of select="@listener"/>
-      </td>
-      <td>
-        <xsl:value-of select="@target"/>
-      </td>
-    </tr>
-  </xsl:template>
-
-</xsl:stylesheet>
-
+        </th></tr><xsl:choose><xsl:when test="string-length($listenerFilter)&gt;0"><xsl:choose><xsl:when test="string-length($targetFilter)&gt;0"><xsl:apply-templates select="event[@listener=$listenerFilter and @target=$targetFilter]"/></xsl:when><xsl:otherwise><xsl:apply-templates select="event[@listener=$listenerFilter]"/></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:apply-templates select="event"/></xsl:otherwise></xsl:choose></table></div></xsl:template><xsl:template match="event"><tr><td><xsl:value-of select="."/></td><td><xsl:value-of select="@listener"/></td><td><xsl:value-of select="@target"/></td></tr></xsl:template></xsl:stylesheet>
